Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 76746)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 76747)
@@ -833,4 +833,5 @@
 	src/medium/viso/UIVisoContentBrowser.h \
 	src/medium/viso/UIVisoCreator.h \
+	src/medium/viso/UIVisoConfigurationDialog.h \
 	src/medium/viso/UIVisoCreatorOptionsDialog.h \
 	src/medium/viso/UIVisoHostBrowser.h \
@@ -1130,4 +1131,5 @@
 	src/medium/viso/UIVisoContentBrowser.h \
 	src/medium/viso/UIVisoCreator.h \
+	src/medium/viso/UIVisoConfigurationDialog.h \
 	src/medium/viso/UIVisoCreatorOptionsDialog.h \
 	src/medium/viso/UIVisoHostBrowser.h \
@@ -1577,4 +1579,5 @@
 	src/medium/viso/UIVisoContentBrowser.cpp \
 	src/medium/viso/UIVisoCreator.cpp \
+	src/medium/viso/UIVisoConfigurationDialog.cpp \
 	src/medium/viso/UIVisoCreatorOptionsDialog.cpp \
 	src/medium/viso/UIVisoHostBrowser.cpp \
@@ -1926,4 +1929,5 @@
 	src/medium/viso/UIVisoContentBrowser.cpp \
 	src/medium/viso/UIVisoCreator.cpp \
+	src/medium/viso/UIVisoConfigurationDialog.cpp \
 	src/medium/viso/UIVisoCreatorOptionsDialog.cpp \
 	src/medium/viso/UIVisoHostBrowser.cpp \
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoConfigurationDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoConfigurationDialog.cpp	(revision 76747)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoConfigurationDialog.cpp	(revision 76747)
@@ -0,0 +1,92 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIVisoConfigurationDialog class implementation.
+ */
+
+/*
+ * Copyright (C) 2006-2019 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/* Qt includes: */
+#include <QCheckBox>
+#include <QGridLayout>
+#include <QPushButton>
+#include <QSplitter>
+#include <QStyle>
+
+/* GUI includes: */
+#include "QIDialogButtonBox.h"
+#include "QILabel.h"
+#include "QILineEdit.h"
+#include "UIVisoConfigurationDialog.h"
+#include "UIVisoCreator.h"
+
+UIVisoConfigurationDialog::UIVisoConfigurationDialog(const VisoOptions &visoOptions,
+                                                     QWidget *pParent /* =0 */)
+    : QIDialog(pParent)
+    , m_pMainLayout(0)
+    , m_pButtonBox(0)
+    , m_visoOptions(visoOptions)
+{
+    prepareObjects();
+    prepareConnections();
+}
+
+UIVisoConfigurationDialog::~UIVisoConfigurationDialog()
+{
+}
+
+const VisoOptions &UIVisoConfigurationDialog::visoOptions() const
+{
+    return m_visoOptions;
+}
+
+void UIVisoConfigurationDialog::sltHandleVisoNameChange(const QString &strText)
+{
+    m_visoOptions.m_strVisoName = strText;
+}
+
+void UIVisoConfigurationDialog::prepareObjects()
+{
+    m_pMainLayout = new QGridLayout;
+
+    if (!m_pMainLayout)
+        return;
+
+
+    QILineEdit *pVisoNameLineEdit = new QILineEdit;
+    connect(pVisoNameLineEdit, &QILineEdit::textChanged,
+            this, &UIVisoConfigurationDialog::sltHandleVisoNameChange);
+    pVisoNameLineEdit->setText(m_visoOptions.m_strVisoName);
+    QILabel *pVisoNameLabel = new QILabel(UIVisoCreator::tr("VISO Name:"));
+    pVisoNameLabel->setBuddy(pVisoNameLineEdit);
+
+    m_pMainLayout->addWidget(pVisoNameLabel, 0, 0, 1, 1);
+    m_pMainLayout->addWidget(pVisoNameLineEdit, 0, 1, 1, 1);
+
+    m_pButtonBox = new QIDialogButtonBox;
+    if (m_pButtonBox)
+    {
+        m_pButtonBox->setStandardButtons(QDialogButtonBox::Cancel | QDialogButtonBox::Ok);
+        m_pButtonBox->button(QDialogButtonBox::Cancel)->setShortcut(Qt::Key_Escape);
+        m_pMainLayout->addWidget(m_pButtonBox, 1, 0, 1, 2);
+    }
+    setLayout(m_pMainLayout);
+}
+
+void UIVisoConfigurationDialog::prepareConnections()
+{
+    if (m_pButtonBox)
+    {
+        connect(m_pButtonBox, &QIDialogButtonBox::rejected, this, &UIVisoConfigurationDialog::close);
+        connect(m_pButtonBox, &QIDialogButtonBox::accepted, this, &UIVisoConfigurationDialog::accept);
+    }
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoConfigurationDialog.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoConfigurationDialog.h	(revision 76747)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoConfigurationDialog.h	(revision 76747)
@@ -0,0 +1,60 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIVisoConfigurationDialog class declaration.
+ */
+
+/*
+ * Copyright (C) 2006-2019 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef FEQT_INCLUDED_SRC_medium_viso_UIVisoConfigurationDialog_h
+#define FEQT_INCLUDED_SRC_medium_viso_UIVisoConfigurationDialog_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+/* GUI includes: */
+#include "QIDialog.h"
+#include "QIWithRetranslateUI.h"
+#include "UIVisoCreatorDefs.h"
+
+/* Forward declarations: */
+class QITabWidget;
+class QGridLayout;
+class QIDialogButtonBox;
+
+class SHARED_LIBRARY_STUFF UIVisoConfigurationDialog : public QIDialog
+{
+    Q_OBJECT;
+
+public:
+
+    UIVisoConfigurationDialog(const VisoOptions &visoOptions,
+                              QWidget *pParent = 0);
+    ~UIVisoConfigurationDialog();
+    const VisoOptions &visoOptions() const;
+
+private slots:
+
+    void sltHandleVisoNameChange(const QString &strText);
+
+private:
+
+    void prepareObjects();
+    void prepareConnections();
+
+    QGridLayout          *m_pMainLayout;
+    QIDialogButtonBox    *m_pButtonBox;
+    VisoOptions          m_visoOptions;
+    friend class UIVisoCreator;
+};
+
+#endif /* !FEQT_INCLUDED_SRC_medium_viso_UIVisoConfigurationDialog_h */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 76746)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 76747)
@@ -28,4 +28,5 @@
 #include "UIVisoHostBrowser.h"
 #include "UIVisoCreator.h"
+#include "UIVisoConfigurationDialog.h"
 #include "UIVisoCreatorOptionsDialog.h"
 #include "UIVisoContentBrowser.h"
@@ -40,4 +41,5 @@
     , m_pButtonBox(0)
     , m_pToolBar(0)
+    , m_pActionConfiguration(0)
     , m_pActionOptions(0)
 {
@@ -66,9 +68,15 @@
 void UIVisoCreator::retranslateUi()
 {
+    if (m_pActionConfiguration)
+    {
+        m_pActionConfiguration->setText(tr("&Configuration..."));
+        m_pActionConfiguration->setToolTip(tr("VISO Configuration"));
+        m_pActionConfiguration->setStatusTip(tr("Manage VISO Configuration"));
+    }
     if (m_pActionOptions)
     {
         m_pActionOptions->setText(tr("&Options..."));
-        m_pActionOptions->setToolTip(tr("VISO Options"));
-        m_pActionOptions->setStatusTip(tr("Manage VISO Options"));
+        m_pActionOptions->setToolTip(tr("Dialog Options"));
+        m_pActionOptions->setStatusTip(tr("Manage Dialog Options"));
     }
 }
@@ -82,5 +90,5 @@
 void UIVisoCreator::sltHandleOptionsAction()
 {
-    UIVisoCreatorOptionsDialog *pDialog = new UIVisoCreatorOptionsDialog(m_visoOptions, m_browserOptions, this);
+    UIVisoCreatorOptionsDialog *pDialog = new UIVisoCreatorOptionsDialog(m_browserOptions, this);
 
     if(!pDialog)
@@ -90,9 +98,21 @@
         /** Check if any of the options has been modified: */
         checkBrowserOptions(pDialog->browserOptions());
+    }
+    delete pDialog;
+}
+
+void UIVisoCreator::sltHandleConfigurationAction()
+{
+    UIVisoConfigurationDialog *pDialog = new UIVisoConfigurationDialog(m_visoOptions, this);
+
+    if(!pDialog)
+        return;
+    if (pDialog->execute(true, false))
+    {
+        /** Check if any of the options has been modified: */
         checkVisoOptions(pDialog->visoOptions());
     }
     delete pDialog;
 }
-
 
 void UIVisoCreator::prepareObjects()
@@ -110,6 +130,9 @@
         m_pToolBar->setToolButtonStyle(Qt::ToolButtonTextUnderIcon);
         /* Add toolbar actions: */
+        if (m_pActionConfiguration)
+            m_pToolBar->addAction(m_pActionConfiguration);
         if (m_pActionOptions)
             m_pToolBar->addAction(m_pActionOptions);
+
         m_pMainLayout->addWidget(m_pToolBar);
     }
@@ -154,13 +177,21 @@
         connect(m_pButtonBox, &QIDialogButtonBox::accepted, this, &UIVisoCreator::accept);
     }
+    if (m_pActionConfiguration)
+        connect(m_pActionConfiguration, &QAction::triggered, this, &UIVisoCreator::sltHandleConfigurationAction);
     if (m_pActionOptions)
-    {
         connect(m_pActionOptions, &QAction::triggered, this, &UIVisoCreator::sltHandleOptionsAction);
-
-    }
 }
 
 void UIVisoCreator::prepareActions()
 {
+    m_pActionConfiguration = new QAction(this);
+    if (m_pActionConfiguration)
+    {
+        m_pActionConfiguration->setIcon(UIIconPool::iconSetFull(":/file_manager_options_32px.png",
+                                                          ":/%file_manager_options_16px.png",
+                                                          ":/file_manager_options_disabled_32px.png",
+                                                          ":/file_manager_options_disabled_16px.png"));
+    }
+
     m_pActionOptions = new QAction(this);
     if (m_pActionOptions)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h	(revision 76746)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h	(revision 76747)
@@ -69,6 +69,7 @@
     void sltHandleAddObjectsToViso(QStringList pathList);
     void sltHandleOptionsAction();
+    void sltHandleConfigurationAction();
 
-private:
+ private:
 
     void prepareObjects();
@@ -87,7 +88,8 @@
     QIDialogButtonBox    *m_pButtonBox;
     UIToolBar            *m_pToolBar;
+    QAction              *m_pActionConfiguration;
     QAction              *m_pActionOptions;
-    VisoOptions          m_visoOptions;
-    BrowserOptions       m_browserOptions;
+    VisoOptions           m_visoOptions;
+    BrowserOptions        m_browserOptions;
 
 };
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreatorOptionsDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreatorOptionsDialog.cpp	(revision 76746)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreatorOptionsDialog.cpp	(revision 76747)
@@ -29,19 +29,11 @@
 #include "QILineEdit.h"
 #include "QITabWidget.h"
-#include "UIIconPool.h"
-#include "UIToolBar.h"
-#include "UIVisoHostBrowser.h"
 #include "UIVisoCreator.h"
 #include "UIVisoCreatorOptionsDialog.h"
-#include "UIVisoContentBrowser.h"
 
-UIVisoCreatorOptionsDialog::UIVisoCreatorOptionsDialog(const VisoOptions &visoOptions,
-                                                       const BrowserOptions &browserOptions,
-                                                       QWidget *pParent /* =0 */)
+UIVisoCreatorOptionsDialog::UIVisoCreatorOptionsDialog(const BrowserOptions &browserOptions, QWidget *pParent /* =0 */)
     : QIDialog(pParent)
     , m_pMainLayout(0)
     , m_pButtonBox(0)
-    , m_pTab(0)
-    , m_visoOptions(visoOptions)
     , m_browserOptions(browserOptions)
 {
@@ -59,9 +51,4 @@
 }
 
-const VisoOptions &UIVisoCreatorOptionsDialog::visoOptions() const
-{
-    return m_visoOptions;
-}
-
 void UIVisoCreatorOptionsDialog::sltHandlShowHiddenObjectsChange(int iState)
 {
@@ -72,31 +59,18 @@
 }
 
-void UIVisoCreatorOptionsDialog::sltHandleVisoNameChange(const QString &strText)
-{
-    m_visoOptions.m_strVisoName = strText;
-}
-
 void UIVisoCreatorOptionsDialog::prepareObjects()
 {
-    m_pMainLayout = new QVBoxLayout;
+    m_pMainLayout = new QGridLayout;
     if (!m_pMainLayout)
         return;
 
-    m_pTab = new QITabWidget;
-    if (m_pTab)
-    {
-        m_pMainLayout->addWidget(m_pTab);
-        m_pTab->insertTab(static_cast<int>(TabPage_VISO_Options), new QWidget, UIVisoCreator::tr("VISO Options"));
-        m_pTab->insertTab(static_cast<int>(TabPage_Browser_Options), new QWidget, UIVisoCreator::tr("Browser Options"));
-
-        m_pTab->setTabToolTip(static_cast<int>(TabPage_VISO_Options), UIVisoCreator::tr("Change VISO options"));
-        m_pTab->setTabWhatsThis(static_cast<int>(TabPage_VISO_Options), UIVisoCreator::tr("Change VISO options"));
-
-        m_pTab->setTabToolTip(static_cast<int>(TabPage_Browser_Options), UIVisoCreator::tr("Change Browser options"));
-        m_pTab->setTabWhatsThis(static_cast<int>(TabPage_Browser_Options), UIVisoCreator::tr("Change Browser options"));
-
-
-    }
-    prepareTabWidget();
+    QCheckBox *pShowHiddenObjectsCheckBox = new QCheckBox;
+    pShowHiddenObjectsCheckBox->setChecked(m_browserOptions.m_bShowHiddenObjects);
+    QILabel *pShowHiddenObjectsLabel = new QILabel(UIVisoCreator::tr("Show Hidden Objects"));
+    pShowHiddenObjectsLabel->setBuddy(pShowHiddenObjectsCheckBox);
+    m_pMainLayout->addWidget(pShowHiddenObjectsLabel, 0, 0);
+    m_pMainLayout->addWidget(pShowHiddenObjectsCheckBox, 0, 1);
+    connect(pShowHiddenObjectsCheckBox, &QCheckBox::stateChanged,
+            this, &UIVisoCreatorOptionsDialog::sltHandlShowHiddenObjectsChange);
 
     m_pButtonBox = new QIDialogButtonBox;
@@ -105,5 +79,5 @@
         m_pButtonBox->setStandardButtons(QDialogButtonBox::Cancel | QDialogButtonBox::Ok);
         m_pButtonBox->button(QDialogButtonBox::Cancel)->setShortcut(Qt::Key_Escape);
-        m_pMainLayout->addWidget(m_pButtonBox);
+        m_pMainLayout->addWidget(m_pButtonBox, 1, 0, 1, 2);
     }
     setLayout(m_pMainLayout);
@@ -118,42 +92,2 @@
     }
 }
-
-void UIVisoCreatorOptionsDialog::prepareTabWidget()
-{
-    if (!m_pTab)
-        return;
-    QWidget *pVisoPage = m_pTab->widget(static_cast<int>(TabPage_VISO_Options));
-    if (pVisoPage)
-    {
-        QGridLayout *pLayout = new QGridLayout;
-
-        QILineEdit *pVisoNameLineEdit = new QILineEdit;
-        connect(pVisoNameLineEdit, &QILineEdit::textChanged,
-                this, &UIVisoCreatorOptionsDialog::sltHandleVisoNameChange);
-        pVisoNameLineEdit->setText(m_visoOptions.m_strVisoName);
-        QILabel *pVisoNameLabel = new QILabel(UIVisoCreator::tr("VISO Name"));
-        pVisoNameLabel->setBuddy(pVisoNameLineEdit);
-
-        pLayout->addWidget(pVisoNameLabel, 0, 0, Qt::AlignTop);
-        pLayout->addWidget(pVisoNameLineEdit, 0, 1, Qt::AlignTop);
-
-        pVisoPage->setLayout(pLayout);
-    }
-
-    QWidget *pBrowserPage = m_pTab->widget(static_cast<int>(TabPage_Browser_Options));
-    if (pBrowserPage)
-    {
-        QGridLayout *pLayout = new QGridLayout;
-
-        QCheckBox *pShowHiddenObjectsCheckBox = new QCheckBox;
-        pShowHiddenObjectsCheckBox->setChecked(m_browserOptions.m_bShowHiddenObjects);
-        QILabel *pShowHiddenObjectsLabel = new QILabel(UIVisoCreator::tr("Show Hidden Objects"));
-        pShowHiddenObjectsLabel->setBuddy(pShowHiddenObjectsCheckBox);
-        pLayout->addWidget(pShowHiddenObjectsLabel, 0, 0, Qt::AlignTop);
-        pLayout->addWidget(pShowHiddenObjectsCheckBox, 0, 1, Qt::AlignTop);
-        connect(pShowHiddenObjectsCheckBox, &QCheckBox::stateChanged,
-                this, &UIVisoCreatorOptionsDialog::sltHandlShowHiddenObjectsChange);
-        pBrowserPage->setLayout(pLayout);
-    }
-
-}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreatorOptionsDialog.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreatorOptionsDialog.h	(revision 76746)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreatorOptionsDialog.h	(revision 76747)
@@ -28,6 +28,5 @@
 
 /* Forward declarations: */
-class QITabWidget;
-class QVBoxLayout;
+class QGridLayout;
 class QIDialogButtonBox;
 
@@ -38,32 +37,19 @@
 public:
 
-    UIVisoCreatorOptionsDialog(const VisoOptions &visoOptions,
-                               const BrowserOptions &browserOptions,
+    UIVisoCreatorOptionsDialog(const BrowserOptions &browserOptions,
                                QWidget *pParent = 0);
     ~UIVisoCreatorOptionsDialog();
     const BrowserOptions &browserOptions() const;
-    const VisoOptions &visoOptions() const;
 
 private slots:
+
     void sltHandlShowHiddenObjectsChange(int iState);
-    void sltHandleVisoNameChange(const QString &strText);
 
 private:
-    enum TabPage
-    {
-        TabPage_VISO_Options,
-        TabPage_Browser_Options,
-        TabPage_Max
-    };
 
     void prepareObjects();
     void prepareConnections();
-    void prepareTabWidget();
-    QVBoxLayout          *m_pMainLayout;
+    QGridLayout          *m_pMainLayout;
     QIDialogButtonBox    *m_pButtonBox;
-    QITabWidget          *m_pTab;
-    //    QILineEdit           *m_pVisoNameLineEdit;
-    //QILabel              *m_pVISONameLabel;
-    VisoOptions          m_visoOptions;
     BrowserOptions       m_browserOptions;
     friend class UIVisoCreator;